import { RTC } from 'phenix-web-sdk'

class cameraController {
    constructor(mediaFactory, $timeout) {

        var self = this;
        self.title = 'Camera Device'; 
        self.videodevices = [];
        self.default = '';
        self.defaultVideoSource = '';
        
        self.$onInit = function () {            
             // All available video sources
            mediaFactory.videoSources().then(function(response){              
                self.videodevices = response.sources;   
                self.defaultVideoSource = response.default;             
                if(response.default) {
                    self.default = response.default; 
                } else {
                    self.default = response.sources[0]; 
                }


                //$timeout(function() {

                    mediaFactory.getMediaStream(self.defaultVideoSource, 'video').then(function(response){
                    
                        let videoElem = document.querySelector('video');

                        if(response) {
                            videoElem = RTC.attachMediaStream(videoElem, response);  
                            mediaFactory.setPreMediaStream(response, 'video');   
                        }
                       
                    })


               // }, 2000)



            })  
        }; 

        self.onSelect = function(data) {     
           
            let constraints = Object.assign({}, mediaFactory.deviceOptions());
            constraints.video = { deviceId: data.id };

            

            mediaFactory.getMediaStreamByConstraint(constraints, 'video').then(function(response){
                let previousMediaStream = mediaFactory.previousMediaStream('video');
                if(response) {
                    if( previousMediaStream !==  response ) {

                        if(previousMediaStream) {
                            const videoTrack = previousMediaStream.getVideoTracks()[0];

                            if (videoTrack) {
                                videoTrack.stop();
                                previousMediaStream.removeTrack(videoTrack);
                            }                            
                        }

                        let videoElem = document.querySelector('video');
                        videoElem = RTC.attachMediaStream(videoElem, response);                       
                        mediaFactory.setPreMediaStream(response, 'video');
                    }                    
                } else {
                    if(previousMediaStream) {
                        const videoTrack = previousMediaStream.getVideoTracks()[0];

                        if (videoTrack) {
                            videoTrack.stop();
                            previousMediaStream.removeTrack(videoTrack);
                        }

                        mediaFactory.setPreMediaStream(false, 'video');                            
                    }
                }
               
            });
           
        }   
       
    }

}

export default cameraController; 